function [a11,a12,d11,d12]=four4m(x,o)
    [nrgout, nrgin]=argn(0);
    
    if nrgin==1 then
        o='t';
   elseif nrgin==2
       if o~='c' & o~='t' then
           disp('Second Parameter! must be ''t'' or ''c''!');
           return;
       end
   else
       disp('Wrong number of inputs!');
       return;
    end
    if nrgout~=4 then
        disp('Wrong number of outputs!');
        return;
    end
    p=size(x);
if length(p)==3 | (min(p(1),p(2))==1)
    disp('Input must be a  two dimensional matrix!')
    return
end
a=[];
d=[];
for i=1:p(1)
    [a1,d1]=four4(x(i,:),o);
    a=[a; a1];
    d=[d; d1];
end
a11=[];
a12=[];
d11=[];
d12=[];
a=a';
d=d';
for i=1:size(a,1)
    [a1,a2]=four4(a(i,:),o);
    [d1,d2]=four4(d(i,:),o);
    a11=[a11; a1];
    a12=[a12; a2];
    d11=[d11; d1];
    d12=[d12; d2];
end
a11=a11';
a12=a12';
d11=d11';
d12=d12';
endfunction
