function y=invfour4m(a11,a12,d11,d12,o)
    [nrgout, nrgin]=argn(0);
    if nrgin==4 then
        o='t';
   elseif nrgin==5
       if (o~='c' & o~='t') then
           disp('Second Parameter! must be ''t'' or ''c''!');
           return;
       end
   else
       disp('Wrong number of inputs!');
       return;
    end
    if nrgout~=1 then
        disp('Wrong number of outputs!');
        return;
    end
    cr=[size(a12,1), size(d11,1) size(d12,1)]-size(a11,1);
    dr=[size(a12,2) size(d11,2) size(d12,2)]-size(a11,2);
    if abs(cr+dr)>0 then
         disp('The sizes of first 4 inputs must be equal!');
         return;
    end
    
    a=[]; d=[];
a11=a11';
d11=d11';
a12=a12';
d12=d12';
for i=1:size(a11,1)
    a1=invfour4(a11(i,:),a12(i,:),o);
    d1=invfour4(d11(i,:),d12(i,:),o);
    a=[a; a1];
    d=[d; d1];
end
y=[];
a=a';
d=d';
for i=1:size(a,1)
    a1=invfour4(a(i,:),d(i,:),o);
    y=[y; a1];
end
endfunction
